/*
+-------------------------------- DISCLAIMER ---------------------------------+
|                                                                             |
| This application program is provided to you free of charge as an example.   |
| Despite the considerable efforts of Euresys personnel to create a usable    |
| example, you should not assume that this program is error-free or suitable  |
| for any purpose whatsoever.                                                 |
|                                                                             |
| EURESYS does not give any representation, warranty or undertaking that this |
| program is free of any defect or error or suitable for any purpose. EURESYS |
| shall not be liable, in contract, in torts or otherwise, for any damages,   |
| loss, costs, expenses or other claims for compensation, including those     |
| asserted by third parties, arising out of or in connection with the use of  |
| this program.                                                               |
|                                                                             |
+-----------------------------------------------------------------------------+
*/

// Helper for Virtual File System _ exception part
// 2.0.0.15


namespace vfd_euresys
{


	// class dedicated to manage error/ exception of other classes
	class vfd_Exception
	{
	private:
		char buf[512];
		int ID;
		char _title[256];
	public :
		vfd_Exception(const char * title, int id )
		{
			ID = id;
			int len = strlen(title);
			len = len >255 ? 255 : len;
			strncpy(_title, title, len);
			_title[len]='\0';
		}
		~vfd_Exception(){}
		char * what()
		{
			switch (ID)
			{
			case 100: sprintf(buf, "%s : Path provided is too long ",_title);
				break;
			case 101: sprintf(buf, "%s : Unable to open config.xml file", _title);
				break;
			case 102: sprintf(buf, "%s : Empty config.xml file", _title);
				break;
			case 103: sprintf(buf, "%s : Config.xml file does not contain %s information", _title, _title);
				break;
			case 104: sprintf(buf, "Xml file is not in verbose mode another application changed the reporting structure");
				break;
			case 105: sprintf(buf, "%s : Unable to open config.xml to write data back", _title);
				break;
			case 106: sprintf(buf, "%s : Unable to write xml header to config.xml", _title);
				break;
			case 107: sprintf(buf, "%s : Unable to write xml element to config.xml", _title);
				break;
			case 108: sprintf(buf, "%s : Unable to close config.xml", _title);
				break;
			case 109: sprintf(buf, "%s : No video detected", _title);
				break;
			case 110: sprintf(buf, "%s : Xml file structure has been updated (newer driver version)", _title);
				break;

			case 201: sprintf(buf, "%s : Visual source is not configured", _title);
				break;
			case 202: sprintf(buf, "%s : Unable to open metadata.xml file", _title);
				break;
			case 203: sprintf(buf, "%s : Empty metadata.xml file", _title);
				break;
			case 204: sprintf(buf, "%s : Metadata.xml file does not contain %s Meta Data information", _title, _title);
				break;
			case 209: sprintf(buf, "%s : Unable to access compressed data file", _title);
				break;
			case 210: sprintf(buf, "%s : Out of memory", _title);
				break;

			case 309: sprintf(buf, "%s : Unable to access raw data file", _title);
				break;
			case 310: sprintf(buf, "%s : Unable to map raw data file", _title);
				break;
			case 311: sprintf(buf, "%s : Unknown color format", _title);
				break;

			}
			return buf;
		}

	};

}
